commit 7d08003fe0af9d7747bd122a4ca86dc3a7fa1dee
Author: freddy77 <freddy77>
Date:   Sat Jul 3 06:57:01 2010 +0000

    other wide encoding merges

diff --git a/ChangeLog b/ChangeLog
index ff202b1..c815f77 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sat Jul  3 08:56:51 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/error.c src/odbc/odbc.c src/odbc/sqlwparams.h:
+	- other wide encoding merges
+
 Sat Jul  3 01:55:38 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsiconv.h src/replacements/iconv.c:
 	- cleanup iconv replacement
@@ -2566,4 +2570,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3052 2010/07/02 23:55:50 freddy77 Exp $
+$Id: ChangeLog,v 1.3053 2010/07/03 06:57:01 freddy77 Exp $
diff --git a/src/odbc/error.c b/src/odbc/error.c
index 7f52af1..f2dd7f6 100644
--- a/src/odbc/error.c
+++ b/src/odbc/error.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: error.c,v 1.61 2010/07/02 14:07:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: error.c,v 1.62 2010/07/03 06:57:02 freddy77 Exp $");
 
 static void odbc_errs_pop(struct _sql_errors *errs);
 static const char *odbc_get_msg(const char *sqlstate);
@@ -500,9 +500,9 @@ sqlstate2to3(char *state)
 	SQLS_MAP("S1T00", "HYT00");
 }
 
-static SQLRETURN
-_SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord, SQLCHAR FAR * szSqlState,
-	       SQLINTEGER FAR * pfNativeError, SQLCHAR * szErrorMsg, SQLSMALLINT cbErrorMsgMax, SQLSMALLINT FAR * pcbErrorMsg)
+#define FUNC NAME(SQLGetDiagRec) (P(SQLSMALLINT,handleType), P(SQLHANDLE,handle), P(SQLSMALLINT,numRecord), PCHAR(szSqlState),\
+	P(SQLINTEGER FAR *,pfNativeError), PCHAR(szErrorMsg), P(SQLSMALLINT,cbErrorMsgMax), P(SQLSMALLINT FAR *,pcbErrorMsg) WIDE)
+#include "sqlwparams.h"
 {
 	SQLRETURN result;
 	struct _sql_errors *errs;
@@ -514,6 +514,9 @@ _SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 
 	SQLINTEGER odbc_ver = SQL_OV_ODBC2;
 
+	tdsdump_log(TDS_DBG_FUNC, "SQLGetDiagRec(%d, %p, %d, %p, %p, %p, %d, %p)\n",
+			handleType, handle, numRecord, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
+
 	if (numRecord <= 0 || cbErrorMsgMax < 0)
 		return SQL_ERROR;
 
@@ -551,9 +554,9 @@ _SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 
 	if (szSqlState) {
 		if (odbc_ver == SQL_OV_ODBC3)
-			strcpy((char *) szSqlState, errs->errs[numRecord].state3);
+			odbc_set_string(dbc, szSqlState, 24, NULL, errs->errs[numRecord].state3, -1 _wide);
 		else
-			strcpy((char *) szSqlState, errs->errs[numRecord].state2);
+			odbc_set_string(dbc, szSqlState, 24, NULL, errs->errs[numRecord].state2, -1 _wide);
 	}
 
 	msg = errs->errs[numRecord].msg;
@@ -605,24 +608,6 @@ _SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 	return result;
 }
 
-#if (ODBCVER >= 0x0300)
-SQLRETURN ODBC_API
-SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord, SQLCHAR FAR * szSqlState,
-	      SQLINTEGER FAR * pfNativeError, SQLCHAR * szErrorMsg, SQLSMALLINT cbErrorMsgMax, SQLSMALLINT FAR * pcbErrorMsg)
-{
-	SQLRETURN ret;
-	
-	tdsdump_log(TDS_DBG_FUNC, "SQLGetDiagRec(%d, %p, %d, %p, %p, %p, %d, %p)\n", 
-			handleType, handle, numRecord, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
-	
-	ret =_SQLGetDiagRec(handleType, handle, numRecord, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
-	
-	tdsdump_log(TDS_DBG_FUNC, "SQLGetDiagRec returning %d\n", ret);
-	
-	return ret;
-}
-
-
 #define FUNC NAME(SQLGetDiagField) (P(SQLSMALLINT,handleType), P(SQLHANDLE,handle), P(SQLSMALLINT,numRecord),\
 	P(SQLSMALLINT,diagIdentifier), P(SQLPOINTER,buffer), P(SQLSMALLINT,cbBuffer), P(SQLSMALLINT FAR *,pcbBuffer) WIDE)
 #include "sqlwparams.h"
@@ -803,4 +788,4 @@ SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord, S
 	}
 	return result;
 }
-#endif
+
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 23eae1d..0a782af 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.538 2010/07/02 14:07:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.539 2010/07/03 06:57:02 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -71,9 +71,6 @@ static SQLRETURN _SQLFreeEnv(SQLHENV henv);
 static SQLRETURN _SQLFreeStmt(SQLHSTMT hstmt, SQLUSMALLINT fOption, int force);
 static SQLRETURN _SQLFreeDesc(SQLHDESC hdesc);
 static SQLRETURN _SQLExecute(TDS_STMT * stmt);
-static SQLRETURN _SQLGetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTEGER BufferLength,
-					    SQLINTEGER * StringLength);
-static SQLRETURN _SQLSetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLINTEGER StringLength _WIDE);
 static SQLRETURN _SQLSetStmtAttr(SQLHSTMT hstmt, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLINTEGER StringLength);
 static SQLRETURN _SQLGetStmtAttr(SQLHSTMT hstmt, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTEGER BufferLength,
 					 SQLINTEGER * StringLength);
@@ -256,7 +253,7 @@ change_autocommit(TDS_DBC * dbc, int state)
 }
 
 static SQLRETURN
-change_database(TDS_DBC * dbc, char *database, int database_len)
+change_database(TDS_DBC * dbc, const char *database, int database_len)
 {
 	TDSSOCKET *tds = dbc->tds_socket;
 
@@ -518,7 +515,7 @@ odbc_prepare(TDS_STMT *stmt)
 
 #ifdef TDS_NO_DM
 	/* Check string length */
-	if (!IS_VALID_LEN(conlen) || conlen == 0) {
+	if (!IS_VALID_LEN(cbConnStrIn) || cbConnStrIn == 0) {
 		odbc_errs_add(&dbc->errs, "HY090", NULL);
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
@@ -1834,7 +1831,7 @@ SQLCancel(SQLHSTMT hstmt)
 	}
 
 	/* data source name */
-	if (szDSN || (*szDSN))
+	if (odbc_get_string_size(cbDSN, szDSN _wide))
 		odbc_dstr_copy(dbc, &dbc->dsn, cbDSN, szDSN _wide);
 	else
 		tds_dstr_copy(&dbc->dsn, "DEFAULT");
@@ -1853,7 +1850,7 @@ SQLCancel(SQLHSTMT hstmt)
 	 * so you do not check in ini file
 	 */
 	/* user id */
-	if (szUID && (*szUID)) {
+	if (odbc_get_string_size(cbUID, szUID _wide)) {
 		if (!odbc_dstr_copy(dbc, &connection->user_name, cbUID, szUID _wide)) {
 			tds_free_connection(connection);
 			odbc_errs_add(&dbc->errs, "HY001", NULL);
@@ -2184,7 +2181,7 @@ SQLColAttribute(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLUSMALLINT fDescType,
 	tdsdump_log(TDS_DBG_FUNC, "SQLColAttribute(%p, %u, %u, %p, %d, %p, %p)\n", 
 			hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc);
 
-	return _SQLColAttribute(hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc);
+	return _SQLColAttribute(hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc _wide0);
 }
 #endif
 
@@ -4655,8 +4652,9 @@ SQLSetParam(SQLHSTMT hstmt, SQLUSMALLINT ipar, SQLSMALLINT fCType, SQLSMALLINT f
 	ODBC_RETURN_(stmt);
 }
 
-static SQLRETURN
-_SQLGetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTEGER BufferLength, SQLINTEGER * StringLength)
+#define FUNC NAME(SQLGetConnectAttr) (P(SQLHDBC,hdbc), P(SQLINTEGER,Attribute), P(SQLPOINTER,Value), P(SQLINTEGER,BufferLength),\
+	P(SQLINTEGER *,StringLength) WIDE)
+#include "sqlwparams.h"
 {
 	const char *p = NULL;
 	SQLRETURN rc;
@@ -4734,17 +4732,6 @@ _SQLGetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTE
 	ODBC_RETURN(dbc, rc);
 }
 
-#if ODBCVER >= 0x300
-SQLRETURN ODBC_API
-SQLGetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTEGER BufferLength, SQLINTEGER * StringLength)
-{
-	tdsdump_log(TDS_DBG_FUNC, "SQLGetConnectAttr(%p, %d, %p, %d, %p)\n", 
-			hdbc, (int)Attribute, Value, (int)BufferLength, StringLength);
-
-	return _SQLGetConnectAttr(hdbc, Attribute, Value, BufferLength, StringLength);
-}
-#endif
-
 SQLRETURN ODBC_API
 SQLGetConnectOption(SQLHDBC hdbc, SQLUSMALLINT fOption, SQLPOINTER pvParam)
 {
@@ -6034,8 +6021,8 @@ SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 }
 
 
-static SQLRETURN
-_SQLSetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLINTEGER StringLength _WIDE)
+#define FUNC NAME(SQLSetConnectAttr) (P(SQLHDBC,hdbc), P(SQLINTEGER,Attribute), P(SQLPOINTER,ValuePtr), P(SQLINTEGER,StringLength) _WIDE)
+#include "sqlwparams.h"
 {
 	SQLULEN u_value = (SQLULEN) (TDS_INTPTR) ValuePtr;
 	int len = 0;
@@ -6124,15 +6111,6 @@ _SQLSetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLI
 }
 
 SQLRETURN ODBC_API
-SQLSetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLINTEGER StringLength)
-{
-	tdsdump_log(TDS_DBG_FUNC, "SQLSetConnectAttr(%p, %d, %p, %d)\n", 
-			hdbc, (int)Attribute, ValuePtr, (int)StringLength);
-
-	return _SQLSetConnectAttr(hdbc, Attribute, ValuePtr, StringLength _wide0);
-}
-
-SQLRETURN ODBC_API
 SQLSetConnectOption(SQLHDBC hdbc, SQLUSMALLINT fOption, SQLULEN vParam)
 {
 	tdsdump_log(TDS_DBG_FUNC, "SQLSetConnectOption(%p, %d, %u)\n", hdbc, fOption, (unsigned)vParam);
diff --git a/src/odbc/sqlwparams.h b/src/odbc/sqlwparams.h
index aef02d4..ad0fd36 100644
--- a/src/odbc/sqlwparams.h
+++ b/src/odbc/sqlwparams.h
@@ -1,5 +1,19 @@
 //#define FUNC NAME(SQLTest) (P(SQLSMALLINT, x), PCHAR(y) WIDE)
 
+
+#undef NAME
+#undef WIDE
+#undef P
+#undef PCHAR
+#define NAME(a) _ ## a
+#define WIDE
+#define P(a,b) a b
+#define PCHAR(a) SQLCHAR* a
+static SQLRETURN FUNC;
+
+
+
+#undef NAME
 #undef WIDE
 #undef P
 #undef PCHAR
@@ -7,6 +21,30 @@
 #define WIDE
 #define P(a,b) a b
 #define PCHAR(a) SQLCHAR* a
-SQLRETURN ODBC_API FUNC
+SQLRETURN ODBC_API FUNC {
+
+#undef NAME
+#undef WIDE
+#undef P
+#undef PCHAR
+#define NAME(a) _ ## a
+#define WIDE
+#define P(a,b) b
+#define PCHAR(a) a
+	return FUNC;
+}
+
+
+#undef NAME
+#undef WIDE
+#undef P
+#undef PCHAR
+#define NAME(a) _ ## a
+#define WIDE
+#define P(a,b) a b
+#define PCHAR(a) SQLCHAR* a
+static SQLRETURN FUNC
+
+
 
 #undef FUNC

